	.586							; 
      .model flat, stdcall				; 32 bit memory model
      option casemap:none				; case sensitive
;...............................................................................
	include windows.inc				; 
	include masm32.inc				; 
	include gdi32.inc					; 
	include user32.inc				; 
	include kernel32.inc				; 
      include comctl32.inc				; 
	include shell32.inc				; 
	include winmm.inc					; 
;...............................................................................
	includelib masm32.lib				; dwtoa
	includelib gdi32.lib				; TextOut
	includelib user32.lib				; CreateWindowEx, UpdateWindow, ShowWindow, CreateDialogParam, 
	includelib kernel32.lib				; GetSystemTime
      includelib comctl32.lib				; CreateStatusWindow; 
	includelib shell32.lib				; ShellAbout
	includelib winmm.lib				; PlaySound
;...............................................................................
	WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD	; 
	WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD	; 
	DlgProc PROTO :HWND,:DWORD,:DWORD,:DWORD	; dialog box procedure
	GunProc PROTO :DWORD,:DWORD			; gun procedure
	BulletProc PROTO :DWORD,:DWORD		; bullet procedure
	TargetProc PROTO :DWORD,:DWORD		; target procedure
;...............................................................................
	wsprintfA PROTO C :DWORD,:VARARG		; 
	wsprintf equ <wsprintfA>			; 
;...............................................................................
;*******************************************************************************
;...............................................................................
	.data							; 
;...............................................................................
;								; winmain variables
;...............................................................................
	hWnd			DD 0				; window handle
	hInstance		DD 0				; instance of momment
	command_line	DD 0				; pointer to command line string for current process
	hIcon			DD 0				; handle to executable icon
	hBmp_m0		DD 0				; handle to main picture
	szClassName		DB 'Class_Name'		; identifying class name to program
;...............................................................................
;								; message box variables
;...............................................................................
	szMessage		DB 'RK NOG!  2001 INNIEA PUB. CO.', 10, 13, 'TINY BUBBLES MAKE ME FEEL FINE!', 0
	program_title	DB 'FREEHAFER''S RK NOG!', 0	; THE ALIEN SPACESHIP!', 0 
	szInfo		DB 'Z or z key fires gun.', 10, 13, 10, 13, 'N or n key moves gun left.', 10, 13, 10, 13, 'M or m key moves gun right.', 0
;...............................................................................
;								; screen variables
;...............................................................................
	screen_width	DD 0				; 
	screen_height	DD 0				; 
	window_width	DD 0				; 
	window_height	DD 0				; 
	starting_window_X	DD 0				; 
	starting_window_Y	DD 0				; 
;...............................................................................
;								; status bar variables
;...............................................................................
	szDate		DB 'THE DATE IS %d/%d/%d.', 0
	szTime		DB ' THE TIME IS ', 0	; time string
	szTis			DB '%d:%d:%d:%d%s', 0	; time is string
	szShot		DB 'SHOTS', 0		; shots
	shots			DD 0				; number of shots
	szHit			DB 'HITS', 0		; hits
	hits			DD 0				; number of hits
	hit_test		DD 0				; was there a hit
	szHello		DB 'HELLO', 0		; hello
	szEnterName		DB 'Click file enter name...', 0
	hStatus		DD 0				; handle to status window
	sbParts		DD 130, 200, 300, 340, 370, 400, 430, 470, -1	; status bar array
;...............................................................................
;								; date variables
;...............................................................................
	stYear		DD 0				; 
	stMonth		DD 0				; 
	stDay			DD 0				; 
;...............................................................................
;								; time variables
;...............................................................................
	stHour		DD 0				; 
	stMinute		DD 0				; 
	stSecond		DD 0				; 
	stMillisecond	DD 0				;  
	szAM			DB ' AM.', 0		; 
	szPM			DB ' PM.', 0		; 
;...............................................................................
;								; wave file path variables
;...............................................................................
	wave_path		DB 'phaser.wav', 0	; phaser sound
	roak_path		DB 'roak.wav', 0		; victory sound
	explode_path	DB 'explode.wav', 0	; explosion sound
;...............................................................................
;								; dialog box variables
;...............................................................................
	DlgName		DB 'TheDialogBox', 0	; null terminated string to identify dialog box in *.rc 
	szYouEntered	DB '%s you are irresistible.', 0
	empty_buffer	DB 40 DUP(?)		; work space
	buffy			DB 60 DUP(?)		; work space
	hwndDlg		DD 0				; handle to dialog box
	County		DW 0				; counter
;...............................................................................
;								; paint variables
;...............................................................................
	bullet_xL		DD 0				; bullet
	bullet_yT		DD 0				; 
	bullet_xR		DD 0				; 
	bullet_yB		DD 0				; 
	store_bullet_x	DD 0				;
	store_bullet_y	DD 0				; 
	test_bullet		DD 0				; 
	target_xL		DD 40				; target
	target_yT		DD 60				; 
	target_xR		DD 60				; 
	target_yB		DD 70				; 
	target_h_test	DD 0				; target horizontal test
	target_v_test	DD 0				; target vertical test
	target_h_store	DD 0				; target horizontal position storage 
	target_v_store	DD 0				; target vertical position storage 
	target_hard		DD 0				; 
	gun_xLeft		DD 230			; gun rect
	gun_yTop		DD 0				; 
	gun_xRight		DD 270			; 
	gun_yBottom		DD 0				; 
	nLeftRect		DD 0				; chord variables
	nTopRect		DD 0				; 
	nRightRect		DD 0				; 
	nBottomRect		DD 0				; 
	nXRadial1		DD 0				;  
	nYRadial1		DD 0				;  	
	nXRadial2		DD 0				;  
	nYRadial2		DD 0				; 
;...............................................................................
	.code							; 
start:							; 
	invoke GetModuleHandle, NULL			; 
	mov hInstance, EAX				; 
	invoke LoadBitmap, hInstance, 200		; load resource bitmap
	mov hBmp_m0, EAX					; 
	invoke GetCommandLine				; 
	mov command_line, EAX				; 
	invoke WinMain, hInstance, NULL, command_line, SW_SHOWDEFAULT
	invoke ExitProcess, EAX				; 
;...............................................................................
;*******************************************************************************
;...............................................................................
WinMain proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
;...............................................................................
	LOCAL wc:WNDCLASSEX				; 
	LOCAL msg:MSG					; 
;...............................................................................
	invoke LoadIcon, hInst, 100			; fill WNDCLASSED structure starting with icon ID
	mov hIcon, EAX					; 
	mov wc.cbSize, sizeof WNDCLASSEX		; 
	mov wc.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	mov wc.lpfnWndProc, offset WndProc		; 
	mov wc.cbClsExtra, NULL				; 
	mov wc.cbWndExtra, NULL				; 
	push hInst						; 
	pop wc.hInstance					; 
	mov wc.hbrBackground, COLOR_BTNFACE + 1	; grey background COLOR_BTNFACE = 15
	mov wc.lpszMenuName, NULL			; 
	mov wc.lpszClassName, offset szClassName	; 
	push hIcon						; 
	pop wc.hIcon					; 
	invoke LoadCursor, NULL, IDC_ARROW		; 
	mov wc.hCursor, EAX				; 
	push hIcon						; 
	pop wc.hIconSm					; 
	invoke RegisterClassEx, ADDR wc		; 
;...............................................................................
	mov window_width, 640				; window width
      invoke GetSystemMetrics, SM_CXSCREEN	; 
	shr EAX, 1						; half screen width
	mov screen_width, EAX				; 
	mov EBX, screen_width				; 
	mov EDX, window_width				; 
	shr EDX, 1						; half desired window width
	sub EBX, EDX					; difference between halves
	mov starting_window_X, EBX			; starting centered X
;...............................................................................
	mov window_height, 291				; window height
	invoke GetSystemMetrics, SM_CYSCREEN	; 
	shr EAX, 1						; half screen height
	mov screen_height, EAX				; 
	mov EBX, screen_height				; 
	mov EDX, window_height				; 
	shr EDX, 1						; half desired window height
	sub EBX, EDX					; difference between halves
	mov starting_window_Y, EBX			; starting centered Y
;...............................................................................
	invoke CreateWindowEx, WS_EX_LEFT, ADDR szClassName, ADDR program_title, WS_OVERLAPPEDWINDOW or WS_SYSMENU, starting_window_X, starting_window_Y, window_width, window_height, NULL, NULL, hInst, NULL
	mov hWnd, EAX					; 
;...............................................................................
	invoke LoadMenu, hInst, 300			; menu ID 
	invoke SetMenu, hWnd, EAX 			; 
;...............................................................................
	invoke ShowWindow, hWnd, SW_NORMAL		; update window
	invoke UpdateWindow, hWnd			; 
;..............................................................................
	.WHILE TRUE						; get message loop
 	invoke GetMessage, ADDR msg, NULL, 0, 0	; 
	.BREAK .IF (!EAX)					; 
	.if hwndDlg != 0					; 
	invoke IsDialogMessage, hwndDlg, ADDR msg	; 
	.if EAX == TRUE					; 
	.continue						; 
	.endif						; 
	.endif						; 
	invoke TranslateMessage, ADDR msg		; 
	invoke DispatchMessage, ADDR msg		; 
	.endw							; 
	mov EAX, msg.wParam				; 
	ret							; 
WinMain endp						; 
;...............................................................................
;*******************************************************************************
;...............................................................................
WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
;...............................................................................
	LOCAL bitmap_rect:RECT				; bitmap rect structure
	LOCAL paint_rect:RECT				; paint rect structure
	LOCAL hDC:DWORD					; handle of a device context or graphics structure
	LOCAL paint_struct:PAINTSTRUCT		; paint structure
	LOCAL memDC:DWORD					; memory of hDC
	LOCAL	old_hdc:DWORD				; store old hDC
	LOCAL hPen:DWORD					; logical pen style
	LOCAL system_time:SYSTEMTIME			; time structure
	LOCAL buffer0[128]:BYTE				; work space
	LOCAL buffer1[128]:BYTE				; work space
	LOCAL wc2:WNDCLASSEX				; child window window class ex
;...............................................................................
	.if uMsg == WM_COMMAND				; WM_COMMAND = 273
;...............................................................................
	.if wParam == 1000				; menu enter your name
;...............................................................................
	invoke CreateDialogParam, hInstance, ADDR DlgName, hWin, OFFSET DlgProc, NULL
	mov hwndDlg,eax
;...............................................................................
	.elseif wParam == 1100 				; menu exit
	invoke SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE,NULL
;...............................................................................
	.elseif wParam == 2000				; difficult menu item
	invoke KillTimer, hWnd, 1			; 
	mov target_hard, 1				; 
	invoke SetTimer, hWnd, 1, 1, 0		; 
;...............................................................................
	.elseif wParam == 2100				; easy default menu item
	invoke KillTimer, hWnd, 1			; 
	mov target_hard, 0				; 
	invoke SetTimer, hWnd, 1, 1, 0		; 
;...............................................................................
	.elseif wParam == 2200				; slow and easy menu item
	invoke KillTimer, hWnd, 1			; 
	mov target_hard, 0				; 
	invoke SetTimer, hWnd, 1, 100, 0		; 
;...............................................................................
	.elseif wParam == 3000 				; information menu
	invoke KillTimer, hWnd, 1			; 
	invoke MessageBox, hWnd, ADDR szInfo, ADDR program_title, MB_OK
	invoke SetTimer, hWnd, 1, 1, 0		; 
;...............................................................................
	.elseif wParam == 3100 				; about menu
	invoke KillTimer, hWnd, 1			; 
	invoke ShellAbout, hWnd, ADDR program_title, ADDR szMessage, hIcon 
 	invoke SetTimer, hWnd, 1, 1, 0		; 
;...............................................................................
	.elseif wParam == 4000 				; status window
	invoke MessageBeep, 0				; 
	.endif						;
	ret							; 
;...............................................................................
	.elseif uMsg == WM_CREATE			; WM_CREATE = 1
	invoke SetTimer, hWin, 1, 1, 0		; 
;...............................................................................
	invoke CreateStatusWindow, WS_CHILD or WS_VISIBLE or SBS_SIZEGRIP, NULL, hWin, 4000
	mov hStatus, EAX					; 
	invoke SendMessage, hStatus, SB_SETPARTS, 9, ADDR sbParts
	invoke SendMessage, hStatus, SB_SETTEXT, 1, ADDR szTime
	invoke SendMessage, hStatus, SB_SETTEXT, 3, ADDR szShot
	invoke SendMessage, hStatus, SB_SETTEXT, 5, ADDR szHit
	invoke SendMessage, hStatus, SB_SETTEXT, 7, ADDR szHello
	invoke SendMessage, hStatus, SB_SETTEXT, 8, ADDR szEnterName
;...............................................................................
	ret							; 
;...............................................................................
	.elseif uMsg == WM_KEYDOWN			; WM_KEYDOWN = 256
	ret							; 
;...............................................................................
	.elseif uMsg == WM_CHAR				; WM_CHAR = 258
	.if wParam == 90 || wParam == 122		; Z or z key for shot
	inc shots						; shot counter
	mov EDX, shots					; 
	invoke dwtoa, EDX, ADDR buffer1		; convert shots to string
	invoke SendMessage, hStatus, SB_SETTEXT, 4, ADDR buffer1
	invoke PlaySound, ADDR wave_path, 0, SND_SYNC 
;..............................................................................
	mov hit_test, 0					; new target no hit
	.if test_bullet != 1				; 
	mov EAX, store_bullet_x				; get starting position x
	add EAX, 2						; 
	mov bullet_xL, EAX				; 
	add EAX, 5						; 
	mov bullet_xR, EAX				; 
	mov EAX, store_bullet_y				; get starting position y
	sub EAX, 10						; 
	mov bullet_yT, EAX				; 
 	add EAX, 5						; 
	mov bullet_yB, EAX				; 
	.endif						; end of bullet path
	mov test_bullet, 1				; 
	.endif						; end of Z or z key
;...............................................................................
	.if wParam == 77 || wParam == 109		; M or m move gun right 
	mov EAX, paint_rect.right			; window width
	.if gun_xRight < EAX				; 
	add gun_xLeft, 5					; 
	add gun_xRight, 5					; 
	.endif						; 
	.endif						; 
;...............................................................................
	.if wParam == 78 || wParam == 110		; N or n move gun left
	.if gun_xLeft > 0					; 
	sub gun_xLeft, 5					; 
	sub gun_xRight, 5					; 
	.endif						; 
	.endif						; 
;...............................................................................
	ret
;...............................................................................
	.elseif uMsg == WM_LBUTTONDOWN		; WM_LBUTTONDOWN = 513
	ret							; 
;...............................................................................
	.elseif uMsg == WM_RBUTTONDOWN		; WM_RBUTTONDOWN = 516
	ret							; 
;...............................................................................
	.elseif uMsg == WM_SIZE				; WM_SIZE = 5
	invoke MoveWindow, hStatus, 0, 0, 0, 0, TRUE
;	mov EAX, 0						; window width
;	mov AX, WORD PTR [ebp + 20]			; LOWORD lParam
;	mov window_width, EAX				; 
;	mov EAX, 0						; window height
;	mov AX, WORD PTR [ebp + 22]			; HIWORD lParam
;	sub EAX, 20						; 
;	mov gun_yBottom, EAX				; 
;	sub EAX, 20						; 
;	mov gun_yTop, EAX					; 
	ret							; 
;...............................................................................
	.elseif uMsg == WM_TIMER			; WM_TIMER = 275
;...............................................................................
	invoke GetLocalTime, ADDR system_time	; time
	mov EAX, 0						; 
	mov AX, system_time.wYear			; 
	mov stYear, EAX					; 
	mov EAX, 0						; 
	mov AX, system_time.wMonth			; 
	mov stMonth, EAX					; 
;	mov EAX, 0						; 
;	mov AX, system_time.wDayOfWeek		; 
	mov EAX, 0						; 
	mov AX, system_time.wDay			; 
	mov stDay, EAX					; 
	mov EAX, 0						; 
	mov AX, system_time.wHour			; 
	mov stHour, EAX					; 
	mov EAX, 0						; 
	mov AX, system_time.wMinute			; 
	mov stMinute, EAX					; 
	mov EAX, 0						; 
	mov AX, system_time.wSecond			; 
	mov stSecond, EAX					; 
	mov EAX, 0						; 
	mov AX, system_time.wMilliseconds		; 
	mov stMillisecond, EAX				; 
	invoke wsprintf, ADDR buffer0, ADDR szDate, stMonth, stDay, stYear 
	.if stHour >= 12					; 
	sub stHour, 12					; 
	.if stHour == 0					; 
	mov stHour, 12					; 
	.endif						; 
	invoke wsprintf, ADDR buffer1, ADDR szTis, stHour, stMinute, stSecond, stMillisecond, ADDR szPM
	.else							; 
	.if stHour == 0					; 
	mov stHour, 12					; 
	.endif						; 
	invoke wsprintf, ADDR buffer1, ADDR szTis, stHour, stMinute, stSecond, stMillisecond, ADDR szAM
	.endif						; 
	invoke SendMessage, hStatus, SB_SETTEXT, 0, ADDR buffer0
	invoke SendMessage, hStatus, SB_SETTEXT, 2, ADDR buffer1
;...............................................................................
	invoke GetClientRect, hWin, ADDR paint_rect	; gun position for top and bottom
	mov EAX, paint_rect.bottom			; 
	sub EAX, 20						; 
	mov gun_yBottom, EAX				; 
	sub EAX, 20						; 
	mov gun_yTop, EAX					; 
;..............................................................................
;								; move target
;..............................................................................
	mov EAX, paint_rect.right			; move target to right or to 632
	mov target_h_store, EAX				; 
	.if target_xR <= EAX && target_h_test == 0; 
	add target_xL, 2					; 
	add target_xR, 2					; 
	sub target_h_store, 20				; 
	mov EAX, target_h_store				; 
	.if target_xL > EAX				; 
	mov target_h_test, 1				; 
	.endif						; 
	.endif						; 
	.if target_xL > 0	&& target_h_test == 1	; move target to left or to 0
	sub target_xL, 2					; 
	sub target_xR, 2					; 
	.if target_xL == 0				; 
	mov target_h_test, 0				; 
	.endif						; 
	.endif						; 
	.if target_yT > 0	&& target_v_test == 0	; move target to top or to 0
	sub target_yT, 2					; 
	sub target_yB, 2					; 
	.if target_yT == 0				; 
	mov target_v_test, 1				; 
	.endif						; 
	.endif						; 
	mov EAX, paint_rect.bottom			; move target down 200
	mov target_v_store, EAX				; 
	.if target_yB <= EAX && target_v_test == 1; 
	add target_yT, 2					; 
	add target_yB, 2					; 
	sub target_v_store, 200				; 
	mov EAX, target_v_store				; 
	.if target_yB > EAX				; 
	mov target_v_test, 0				; 
	.endif						; 
	.endif						; 
;...............................................................................
;								; bullet
;...............................................................................
	.if test_bullet == 1				; yes bullet is fired
	.while bullet_yT > 2 && hit_test != 1	; 2 is as low as we can go ****
;..............................................................................
;								; move target while shooting
;..............................................................................
	.if target_hard == 1				; 
	mov EAX, paint_rect.right			; move target to right or to 632
	mov target_h_store, EAX				; 
	.if target_xR <= EAX && target_h_test == 0; 
	add target_xL, 2					; 
	add target_xR, 2					; 
	sub target_h_store, 20				; 
	mov EAX, target_h_store				; 
	.if target_xL > EAX				; 
	mov target_h_test, 1				; 
	.endif						; 
	.endif						; 
	.if target_xL > 0	&& target_h_test == 1	; move target to left or to 0
	sub target_xL, 2					; 
	sub target_xR, 2					; 
	.if target_xL == 0				; 
	mov target_h_test, 0				; 
	.endif						; 
	.endif						; 
	.if target_yT > 0	&& target_v_test == 0	; move target to top or to 0
	sub target_yT, 2					; 
	sub target_yB, 2					; 
	.if target_yT == 0				; 
	mov target_v_test, 1				; 
	.endif						; 
	.endif						; 
	mov EAX, paint_rect.bottom			; move target down 200
	mov target_v_store, EAX				; 
	.if target_yB <= EAX && target_v_test == 1; 
	add target_yT, 2					; 
	add target_yB, 2					; 
	sub target_v_store, 200				; 
	mov EAX, target_v_store				; 
	.if target_yB > EAX				; 
	mov target_v_test, 0				; 
	.endif						; 
	.endif						; 
	.endif						; 
;..............................................................................
	sub bullet_yT, 2					; 
	sub bullet_yB, 2					; 
;..............................................................................
;								; hits
;..............................................................................
	mov EAX, target_xL				; 
	mov EBX, target_yT				; 
	mov ECX, target_xR				; 
	mov EDX, target_yB				; 
	.if bullet_xR >= EAX && bullet_yT <= EBX && bullet_xL <= ECX && bullet_yB <= EDX
	mov hit_test, 1					; there was a hit
	inc hits						; 
	mov EDX, hits					; 
	invoke dwtoa, EDX, ADDR buffer1		; 
	invoke SendMessage, hStatus, SB_SETTEXT, 6, ADDR buffer1
	.if target_hard == 0				; 
	invoke PlaySound, ADDR explode_path, 0, SND_SYNC
	.endif						; 
	.if target_hard == 1				; 
	invoke PlaySound, ADDR roak_path, 0, SND_SYNC
	.endif						;  
	mov target_xL, 0					; get rid of target
	mov target_yT, 0					; 
	mov target_xR, 0					; 
	mov target_yB, 0					; 
	mov target_xL, 340				; create new target
	mov target_yT, 160				; 
	mov target_xR, 360				; 
	mov target_yB, 170				; 
	.endif
;..............................................................................
	invoke InvalidateRect, hWin, ADDR paint_rect, 0; repaint bullet but not bakckground bitmap 0 for FALSE
	invoke UpdateWindow, hWin			; 
	.endw							; end of shoot bullet loop***
	mov test_bullet, 0				; bullet is gone
	.endif						; 
	mov bullet_xL, 0					; zero out bullet so no longer seen
	mov bullet_yT, 0					; 
	mov bullet_xR, 0					; 
	mov bullet_yB, 0					; 
;...............................................................................
	invoke InvalidateRect, hWin, ADDR paint_rect, 0; repaint gun but not bakckground bitmap 0 for FALSE
;...............................................................................
	invoke InvalidateRect, hWin, ADDR bitmap_rect, 0; repaint all but background bitmap 0 for FALSE
	invoke UpdateWindow, hWin			; 
;...............................................................................
	ret							; 
;...............................................................................
	.elseif uMsg == WM_PAINT			; WM_PAINT = 15 
;...............................................................................
	invoke BeginPaint, hWin, ADDR paint_struct; 
	mov hDC, EAX					; 
	invoke CreateCompatibleDC, hDC		; create memory device context
	mov memDC, EAX					; 
	invoke SelectObject, memDC, hBmp_m0		; save old hDC
	mov old_hdc, EAX					; 
	invoke GetClientRect, hWin, ADDR bitmap_rect	; 
	invoke StretchBlt, hDC, 0, 0, bitmap_rect.right, bitmap_rect.bottom, memDC, 0, 0, 640, 291, SRCCOPY
	invoke SelectObject, hDC, old_hdc		; reselect the old hDC
	invoke DeleteDC, memDC				; delete the memory device context 
	invoke GunProc, hWin, hDC			; gun procedure
	invoke BulletProc, hWin, hDC			; bullet procedure
	invoke TargetProc, hWin, hDC			; target procedure
	invoke EndPaint, hWin, ADDR paint_struct	;  
	ret							; 
;...............................................................................
	.elseif uMsg == WM_CLOSE			; 
	.elseif uMsg == WM_DESTROY			; 
	invoke PostQuitMessage, NULL			; 
	mov EAX, 0						; 
	ret							; 
	.endif						; 
	invoke DefWindowProc, hWin, uMsg, wParam, lParam
	ret							; 
WndProc endp						;  
;...............................................................................
;*******************************************************************************
;...............................................................................
DlgProc PROC hDlgWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
	.if iMsg == WM_INITDIALOG			; 
	invoke GetDlgItem, hDlgWnd, 4000		; IDC_EDIT = 4000
	invoke SetFocus, EAX				; 
	.elseif iMsg == WM_CLOSE			; 
	invoke EndDialog, hDlgWnd, NULL		; 
	mov hwndDlg, 0					; 
	.elseif iMsg==WM_COMMAND			; 
	mov EAX, wParam					; 
	mov EDX, EAX					; 
	shr EDX, 16						; 
	.if DX == BN_CLICKED				; 
	.if EAX == 4200					; IDC_OK = 4200
	invoke SendMessage, hDlgWnd, WM_CLOSE, NULL, NULL
	.elseif EAX == 4100				; IDC_ENTER = 4100
;...............................................................................
;								; flush buffer
;...............................................................................
	push EAX						; 
	push EBX						; 
	push ECX						; 
	mov EBX, 0						; 
z_clear_loop:						; 
	mov AL, 0						; 
	mov empty_buffer[EBX], AL			; 
	inc EBX						; 
	.if EBX < 40					; 
	jmp z_clear_loop					; 
	.endif						; 
	pop ECX						; 
	pop EBX						; 
	pop EAX						; 
;...............................................................................
	invoke GetDlgItemText, hDlgWnd, 4000, ADDR empty_buffer, 40
	invoke wsprintf, ADDR buffy, ADDR szYouEntered, ADDR empty_buffer
	invoke SendMessage, hStatus, SB_SETTEXT, 8, ADDR buffy
	.endif						; 
	.endif						; 
	.else							; 
	mov EAX, FALSE					; 
	ret							; 
	.endif						; 
	mov EAX, TRUE					; 
	ret							; 
DlgProc endp						; 
;...............................................................................
;*******************************************************************************
;...............................................................................
GunProc proc hWin:DWORD, hDC:DWORD			; drawing tools
	LOCAL hPen:DWORD					; 
	LOCAL hPenOld:DWORD				; 
	LOCAL hBrush:DWORD				; 
	LOCAL hBrushOld:DWORD				; 
	LOCAL lb:LOGBRUSH					; 
;...............................................................................
;								; bottom track part of gun
;...............................................................................
	invoke CreatePen, 0, 1, 00000FFh		; red outside 0bbggrrh
	mov hPen, EAX					; 
	mov lb.lbStyle, BS_SOLID			; 
	mov lb.lbColor, 0000000h			; black inside
	mov lb.lbHatch, NULL				; 
	invoke CreateBrushIndirect, ADDR lb		; 
	mov hBrush, EAX					; 
	invoke SelectObject, hDC, hPen		; 
	mov hPenOld, EAX					; 
	invoke SelectObject, hDC, hBrush		; 
	mov hBrushOld, EAX				; 
	invoke Ellipse, hDC, gun_xLeft, gun_yTop, gun_xRight, gun_yBottom; lx, ly, rx, ry
	invoke SelectObject, hDC, hBrushOld		; 
	invoke DeleteObject, hBrush			; 
	invoke SelectObject, hDC, hPenOld		; 
	invoke DeleteObject, hPen			; 
;...............................................................................
;								; top cannon part of gun
;...............................................................................
	invoke CreatePen, 0, 1, 0FF00FFh		; purple outside 0bbggrrh
	mov hPen, EAX					; 
	mov lb.lbStyle, BS_SOLID			; 
	mov lb.lbColor, 066FF66h			; green inside
	mov lb.lbHatch, NULL				; 
	invoke CreateBrushIndirect, ADDR lb		; 
	mov hBrush, EAX					; 
	invoke SelectObject, hDC, hPen		; 
	mov hPenOld, EAX					; 
	invoke SelectObject, hDC, hBrush		; 
	mov hBrushOld, EAX				; 
;...............................................................................
	mov EAX, gun_xLeft				; bottom is 40 wide
	add EAX, 16						; 
	mov store_bullet_x, EAX				; store bullet position
	mov EBX, gun_yTop					; 
	sub EBX, 18						; 
	mov store_bullet_y, EBX				; store bullet position
	mov ECX, gun_xRight				; 
	sub ECX, 16						; 
	mov EDX, gun_yBottom				; 
	sub EDX, 18						; 
	invoke Rectangle, hDC, EAX, EBX, ECX, EDX	; lx, ly, rx, ry
;...............................................................................
	invoke SelectObject, hDC, hBrushOld		; 
	invoke DeleteObject, hBrush			; 
	invoke SelectObject, hDC, hPenOld		; 
	invoke DeleteObject, hPen			; 
;...............................................................................
;								; middle chord of gun
;...............................................................................
	invoke CreatePen, 0, 1, 088CCFFh		; beige 0bbggrrh
	mov hPen, EAX					; 
	mov lb.lbStyle, BS_SOLID			; 
	mov lb.lbColor, 088CCFFh			; beige
	mov lb.lbHatch, NULL				; 
	invoke CreateBrushIndirect, ADDR lb		; 
	mov hBrush, EAX					; 
	invoke SelectObject, hDC, hPen		; 
	mov hPenOld, EAX					; 
	invoke SelectObject, hDC, hBrush		; 
	mov hBrushOld, EAX				; 
;...............................................................................
	mov EAX, gun_xLeft				; nLeftRect = x-coordinate of the upper-left corner of the bounding rectangle
	sub EAX, 3						; 
	mov nLeftRect, EAX				; 
	mov EAX, gun_yTop					; nTopRect = y-coordinate of the upper-left corner of the bounding rectangle
	sub EAX, 3						; 
	mov nTopRect, EAX					; 
	mov EAX, gun_xRight				; nRightRect = x-coordinate of the lower-right corner of the bounding rectangle
	add EAX, 3						; 
	mov nRightRect, EAX				; 
	mov EAX, gun_yBottom				; nBottomRect = y-coordinate of the lower-right corner of the bounding rectangle
	sub EAX, 10						; 
	mov nBottomRect, EAX				; 
	mov EAX, nLeftRect				; nXRadial1 = x-coordinate of the first radials endpoint
	mov nXRadial1, EAX				; 
	mov EAX, nTopRect					; nYRadial1 = y-coordinate of the first radials endpoint
	mov nYRadial1, EAX				; 
	mov EAX, nRightRect				; nXRadial2 = x-coordinate of the second radials endpoint 
	mov nXRadial2, EAX				; 
	mov EAX, nBottomRect				; nYRadial2 = y-coordinate of the second radials endpoint 
	shr EAX, 1						; 
	mov nYRadial2, EAX				; 
	invoke Chord, hDC, nLeftRect, nTopRect, nRightRect, nBottomRect, nXRadial1, nYRadial1, nXRadial2, nYRadial2
;...............................................................................
	invoke SelectObject, hDC, hBrushOld		; 
	invoke DeleteObject, hBrush			; 
	invoke SelectObject, hDC, hPenOld		; 
	invoke DeleteObject, hPen			; 
	ret							; 
GunProc endp						; 
;...............................................................................
;*******************************************************************************
;...............................................................................
BulletProc proc hWin:DWORD, hDC:DWORD		; drawing tools
	LOCAL hPen:DWORD					; 
	LOCAL hPenOld:DWORD				; 
	LOCAL hBrush:DWORD				; 
	LOCAL hBrushOld:DWORD				; 
	LOCAL lb:LOGBRUSH					; 
	invoke CreatePen, 0, 1, 00000FFh		; red outside 0bbggrrh
	mov hPen, EAX					; 
	mov lb.lbStyle, BS_SOLID			; 
	mov lb.lbColor, 00000FFh			; red inside
	mov lb.lbHatch, NULL				; 
	invoke CreateBrushIndirect, ADDR lb		; 
	mov hBrush, EAX					; 
	invoke SelectObject, hDC, hPen		; 
	mov hPenOld, EAX					; 
	invoke SelectObject, hDC, hBrush		; 
	mov hBrushOld, EAX				; 
	invoke Ellipse, hDC, bullet_xL, bullet_yT, bullet_xR, bullet_yB
	invoke SelectObject, hDC, hBrushOld		; 
	invoke DeleteObject, hBrush			; 
	invoke SelectObject, hDC, hPenOld		; 
	invoke DeleteObject, hPen			; 
	ret							; 
BulletProc endp						; 
;...............................................................................
;*******************************************************************************
;...............................................................................
TargetProc proc hWin:DWORD, hDC:DWORD		; drawing tools
	LOCAL hPen:DWORD					; 
	LOCAL hPenOld:DWORD				; 
	LOCAL hBrush:DWORD				; 
	LOCAL hBrushOld:DWORD				; 
	LOCAL lb:LOGBRUSH					; 
	invoke CreatePen, 0, 1, 078DECFh		; outside color 0bbggrrh
	mov hPen, EAX					; 
	mov lb.lbStyle, BS_SOLID			; 
	mov lb.lbColor, 078DECFh			; inside color
	mov lb.lbHatch, NULL				; 
	invoke CreateBrushIndirect, ADDR lb		; 
	mov hBrush, EAX					; 
	invoke SelectObject, hDC, hPen		; 
	mov hPenOld, EAX					; 
	invoke SelectObject, hDC, hBrush		; 
	mov hBrushOld, EAX				; 
	invoke Ellipse, hDC, target_xL, target_yT, target_xR, target_yB 
	invoke SelectObject, hDC, hBrushOld		; 
	invoke DeleteObject, hBrush			; 
	invoke SelectObject, hDC, hPenOld		; 
	invoke DeleteObject, hPen			; 
;...............................................................................
;								; draw line
;...............................................................................
	invoke CreatePen, 0, 1, 0FFFFFFh		; outside color 0bbggrrh
	mov hPen, EAX					; 
	mov lb.lbStyle, BS_SOLID			; 
	mov lb.lbColor, 0FFFFFFh			; inside color
	mov lb.lbHatch, NULL				; 
	mov EAX, target_yT				; draw line across 10 by 20 saucer
	add EAX, 5						; 
	invoke MoveToEx, hDC, target_xL, EAX, NULL; 
	mov EAX, target_yB				; 
	sub EAX, 5						; 
	invoke LineTo, hDC, target_xR, EAX		;
	invoke SelectObject, hDC, hBrushOld		; 
	invoke DeleteObject, hBrush			; 
	invoke SelectObject, hDC, hPenOld		; 
	invoke DeleteObject, hPen			; 
;...............................................................................
;								; draw bottom light
;...............................................................................
	invoke CreatePen, 0, 1, 00000FFh		; outside color 0bbggrrh
	mov hPen, EAX					; 
	mov lb.lbStyle, BS_SOLID			; 
	mov lb.lbColor, 00000FFh			; inside color
	mov lb.lbHatch, NULL				; 
	mov EAX, target_xL				; 
	add EAX, 7						; 
	mov EBX, target_xR				; 
	sub EBX, 7						; 
	mov ECX, target_yB				; 
	add ECX, 4						; 
	invoke Ellipse, hDC, EAX, target_yB, EBX, ECX	; LTRB
	invoke SelectObject, hDC, hBrushOld		; 
	invoke DeleteObject, hBrush			; 
	invoke SelectObject, hDC, hPenOld		; 
	invoke DeleteObject, hPen			; 
	ret							; 
TargetProc endp						;
;...............................................................................
;*******************************************************************************
;...............................................................................
end start							; 
